


     [1mFIZ(1)                         (Jan 31, 1988))                    FIZ(1)[0m



     [1mNAME[0m
          fiz - analyze damaged zoo archive for data revovery

     [1mSYNOPSIS[0m
          [4mfiz[0m archive[[1m.zoo[0m]

     [1mDESCRIPTION[0m
          [4mFiz[0m is used to analyze damaged [4mzoo[0m archives and locate
          directory entries and file data in them.  The current
          version of [4mfiz[0m is 2.0 and it is meant to be used in
          conjunction with [4mzoo[0m version 2.0.  [4mFiz[0m makes no assumptions
          about archive structure.  Instead, it simply searches the
          entire subject archive for tag values that mark the
          locations of directory entries and file data.  In a [4mzoo[0m
          archive, a [4mdirectory[0m [4mentry[0m contains information about a
          stored file such as its name, whether compressed or not, and
          its timestamp.  The [4mfile[0m [4mdata[0m are the actual data for the
          archived file, and may be either the original data, or the
          result of compressing the file.

          For each directory entry found, [4mfiz[0m prints where in the
          archive it is located, the directory path and filename(s)
          found in it, whether the directory entry appears to be
          corrupted (indicated by [*CRC Error*]), and the value of the
          pointer to the file data that is found in the directory
          entry.  For each block of file data found in the archive,
          [4mfiz[0m prints where in the archive the block begins.  In the
          case of an undamaged archive, the pointer to file data found
          in a directory entry will correspond to where [4mfiz[0m actually
          locates the data.  Here is some sample output from [4mfiz[0m:

          ****************
              2526: DIR         [changes] ==>         95
              2587: DATA
          ****************
              3909: DIR         [copyrite] ==>        1478
              3970: DATA
              4769: DATA
          ****************

          In such output, [1mDIR[0m indicates where [4mfiz[0m found a directory
          entry in the archive, and [1mDATA[0m indicates where [4mfiz[0m found
          file data in the archive.  Filenames located by [4mfiz[0m are
          enclosed in square brackets, and the notation "==>   95"
          indicates that the directory entry found by [4mfiz[0m at position
          2526 has a file data pointer to position 95. In actuality,
          [4mfiz[0m found file data at positions 2587, 3970, and 4769.
          Since [4mfiz[0m found only two directory entries, and each
          directory entry corresponds to one file, one of the file
          data positions is an artifact.

          Once the locations of directory entries and file data are
          found, the [1m@[0m modifier to [4mzoo's[0m archive list and extract
          commands can be used and the archive contents selectively
          listed or extracted, skipping the damaged portion.  This is
          further described in the documentation for [4mzoo[0m([4m1[0m).

          In the above case, commands to try giving to [4mzoo[0m might be
          [1mx@2526,2587[0m (extract beginning at position 2526, and get
          file data from position 2587), [1mx@3090,3970[0m (extract at 3090,
          get data from 3970) and [1mx@3909,4769[0m (extract at 3909, get
          data from 4769).  Once a correctly-matched directory
          entry/file data pair is found, [4mzoo[0m will in most cases
          synchronize with and correctly extract all files
          subsequently found in the archive.  Trial and error should
          allow all undamaged files to be extracted.  Also note that
          self-extracting archives created using [4msez[0m (the Self-
          Extracting [4mZoo[0m utility for MS-DOS), which are normally
          executed on an MS-DOS system for extraction, can be
          extracted on non-MSDOS systems in a similar way.

     [1mSEE ALSO[0m
          zoo(1)

     [1mBUGS[0m
          Random byte patterns can occasionally be incorrectly
          recognized as tag values.  This occurs very rarely, however,
          and trial and error will usually permit all undamaged data
          to be extracted.

     [1mDIAGNOSTICS[0m
          [4mFiz[0m always exits with a status code of 0.

     [1mFUTURE DIRECTIONS[0m
          Automation of data recovery from a damaged archive is
          potentially achievable.  However, since damaged archives
          occur only rarely, [4mfiz[0m as it currently stands is unlikely to
          change much in the near future.

     [1mAUTHOR[0m
          Rahul Dhesi
